import $, { type } from 'jquery';
import { validateURL } from '../utils/utils';
import 'isomorphic-fetch';

const getParticipatingOrganizations = (url) => {
  if (validateURL(url)) {
    return new Promise((resolve, reject) =>
      fetch(url)
        .then((response) => {
          if (response.status !== 200) {
            throw `${response.status}: ${response.statusText}`;
          }
          response
            .json()
            .then((data) => {
              let orgs = data;
              $(orgs).each(function (key, org) {
                orgs[key].version = 'none';
              });

              orgs.sort((a, b) => a.name.localeCompare(b.name));
              resolve(orgs);
            })
            .catch(reject);
        })
        .catch((err) => {
          reject(err);
        })
    );
  }
};

export default getParticipatingOrganizations;
